#include <cstdio>
#include <algorithm>
#include <map>
#include <string>
#include <vector>

using namespace std;

const char INF = 120;

struct naukowiec
{
  char rok[100];
  char stat[100];
  unsigned char licznik;
  void Zeruj()
  {
    licznik = 0;
  }
  char Erdos() const
  {
    if (licznik > 0)
      return stat[licznik-1];
    else
      return INF;
  }
  char Erdos(char r) const
  {
    if(licznik<=0)
      return INF;
    if(r < rok[0])
      return INF;
    if(r >= rok[licznik-1])
      return stat[licznik-1];
    int l = lower_bound(rok, rok + licznik, r) - rok;
    if (rok[l] > r)
      l--;
    return stat[l];
  } 
  void Publikuj(char r, char s)
  {
    if (s < Erdos())
    {
      if (licznik > 0 && r == rok[licznik-1])
        licznik--;
      else
        rok[licznik] = r;
      stat[licznik++] = s;
    }
  }
  void Wypisz() const
  {
    for(int i=0;i<licznik;i++)
      printf("  %d : %d", rok[i]+1900, stat[i]);
    printf("\n");
  }
};

naukowiec naukowcy[100000];

struct publikacja
{
  char rok;
  int autorzy[10];
  unsigned char licznik;
  void Czytaj(int& f, map<string,int>& m, string* n)
  {
    char buf[256];
    int r;
    scanf("%d",&r);
    rok = r-1900;
    licznik = 0;
    while(scanf(" %[A-Za-z]",buf))
    {
      string s(buf);
      map<string,int>::iterator i=m.find(s);
      if (i!=m.end())
        autorzy[licznik++] = i->second;
      else
      {
        autorzy[licznik++] = f;
        n[f] = s;
        m[s] = f;
        f++;
      }
    }
  }
  void Publikuj()
  {
    char e=INF;
    for(int i = 0;i<licznik;i++)
      e = min(e,naukowcy[autorzy[i]].Erdos(rok-1));
    if(e<INF);
      for(int i = 0;i<licznik;i++)
        naukowcy[autorzy[i]].Publikuj(rok,e+1);
  }
  void Wypisz()
  {
    printf("%d :", rok+1900);
    for(int i=0;i<licznik;i++)
      printf(" %d",autorzy[i]);
    printf("\n");
  }
  bool operator< (const publikacja& o) const
  {
    return rok < o.rok;
  }
};


map<string,int> M;
string N[100000];
publikacja pub[100000];

int main()
{
  int Z;
  scanf("%d",&Z);
  for(int z=0;z<Z;z++)
  {
    int P,Q;
    int F=0;
    scanf("%d%d",&P,&Q);
    for(int i=0;i<P;i++)
      pub[i].Czytaj(F,M,N);
    sort(pub, pub+P);
    for(int i=0;i<F;i++)
      naukowcy[i].Zeruj();
    if(M.find("Erdos") != M.end())
      naukowcy[M["Erdos"]].Publikuj(0,0);
    for(int i=0;i<P;i++)
      pub[i].Publikuj();
    /*
    for(int i=0;i<F;i++)
    {
      printf("%d -> '%s'",i,N[i].c_str());
      naukowcy[i].Wypisz();
    }
    for(int i=0;i<P;i++)
      pub[i].Wypisz();
    */
    for(int i=0;i<Q;i++)
    {
      int r;
      char buf[256];
      scanf("%d %s", &r, buf);
      r -= 1900;
      map<string,int>::iterator j = M.find(buf);
      if(j != M.end() && naukowcy[j->second].Erdos(r) < INF)
        printf("%d\n", naukowcy[j->second].Erdos(r));
      else
        printf("NIESKONCZONA\n");
    }
    M.clear();
  }
  return 0;
}
